DBFILE

! subroutine to read stresses in integration points and save to common block
      subroutine uvarm(uvar,direct,t,time,dtime,cmname,orname,
     1 nuvarm,noel,npt,layer,kspt,kstep,kinc,ndi,nshr,coord,
     2 jmac,jmatyp,matlayo,laccfla)
      include 'aba_param.inc'

      character*80 cmname,orname
      character*3 flgray(15)
      dimension uvar(nuvarm),direct(3,3),t(3,3),time(2)
      dimension array(15),jarray(15),jmac(*),jmatyp(*),coord(*)

      common /sharedf/ s(4,6)     
      common /sharedf/ wsp(4,3)
!     s - stress (integration point, stress component)
      
      if (npt.le.4) then
        call getvrm('s',array,jarray,flgray,jrcd,jmac,jmatyp,matlayo,laccfla)
        do k1=1, 6
          s(npt,k1)=array(k1)
        end do      
      end if
      
      return
      end
  
! subroutine that runs once per increment. It is used to read the result file, but here it is used as the place for main calculations of the crack propagation angle
      subroutine urdfil(lstop,lovrwrt,kstep,kinc,dtime,time)
      include 'aba_param.inc'

      dimension array(513),jrray(nprecd,513),time(2),node(99999,4),
     1 coordip(99999,2),coordnode(99999,2),coor(300,2),
     2 omi3(99999),angle(300),omi(300),
     3 x(7,7), y(7), z(7)
      equivalence (array(1),jrray(1,1))
      
      common /shared/ p(99999)
      common /shared/ node
      common /shared/ anglelast,nmax,nmin,notfirstinc
      common /crack/ ft,anglenew,ndij

      call posfil(kstep,kinc,array,jrcd)
!     assigning nodes to elements
      if (notfirstinc.eq.0) call obtain_relation(node) 
      
!     key 904: array(3)=node, array(4)=philsm
!     key 905: array(3)=node, array(4)=psilsm
!     key 107: array(3)=node, array(4)=cx array(5)=cy coordinate
!     key 101: array(3)=node, array(4)=ux array(5)=uy displacements
!     p - philsm, nmax - node with philsm(+), nmin - node with philsm(-), xnmax,xnmin,ynmax,ynmin - coordinates of these nodes
!     ne - number of nodes, nec - number of nodes around the crack, radius - radius in which the nodes are selected around the cracktip.

      pi=3.1415926535
      k1=0
      nip=0
!     checks if a crack has already been committed somewhere. If not, it assumes the coordinates of the crack tip as the node with the largest ps.
      isphilsm=0
!     isgrow is to check if the crack has grown in this increment
      isgrow=0
!     the location of maximum principal stresses in the entire model, used to determine the coordinates of the crack tip when the crack does not exist yet
      psmax=0
      
! reading the "result" file
      do
        call dbfile(0,jrray,jrcd)
        key=jrray(1,2)    
        if (key.eq.1911) k1=0   
        if ((key.eq.8).and.(not(isnan(array(3))))) then
          k1=k1+1
          nip=nip+1  
          coordip(k1,1)=array(3)
          coordip(k1,2)=array(4)
        end if
        if ((key.eq.11).and.(not(isnan(array(3))))) then
          s11=array(3)
          s22=array(4)
          if (ndij.eq.2) then
            s12=array(5)
            s33=0
          else
            s12=array(6)
            s33=array(5)
          end if
          zi1=s11+s22+s33
          zi2=s11*s22+s22*s33+s33*s11-s12*s12
          zi3=s11*s22*s33-s12*s12*s33
          fi=acos((2.0*zi1**3.0-9.0*zi1*zi2+27.0*zi3)/2.0/(zi1**2.0-3.0*zi2)**1.5)/3.0
          omi3(k1)=(abs(zi1/3.0+2.0*sqrt(zi1**2.0-3.0*zi2)*cos(fi)/3.0))/ft
          if (omi3(k1).gt.psmax) then
            psmax=omi3(k1)
            rotangle=atan(s12*2.0/(s11-s22))/2.0
            if ((s11-s22)*cos(2.0*rotangle).ge.0.0) rotangle=rotangle-pi/2.0
            nmaxps=k1
          end if
        end if     
        if (key.eq.904) then
          k1=k1+1
          if (p(k1).ne.array(4)) then
            p(k1)=array(4)
            isgrow=1
          end if
          lw=k1
          if (p(k1).gt.0.0) isphilsm=1
        end if 
        if (key.eq.107) then
          k1=k1+1
          coordnode(k1-lw,1)=array(4)
          coordnode(k1-lw,2)=array(5)                                
        end if  
        if (jrcd.ne.0) exit
      end do 

      if (isgrow.eq.1) anglelast=anglenew
      
! determining in which element the crack tip is located
      do i=1,abs(0.25*nip)
        licznikmax=0
        licznikmin=0
        licznik0=0
        pmax=1000000.0
        pmin=-1000000.0        
        do j=1,4
          if ((p(node(i,j)).gt.0).and.(p(node(i,j)).lt.pmax)) then
            pmax=p(node(i,j))
            licznikmax=j
          end if
          if ((p(node(i,j)).lt.0).and.(p(node(i,j)).gt.pmin)) then
            pmin=p(node(i,j))
            licznikmin=j
          end if
          if (p(node(i,j)).lt.-1e30) licznik0=licznik0+1
        end do
        if ((licznikmax.gt.0).and.(licznikmin.gt.0).and.(licznik0.ge.1)) then
          lastcracked=i
          nmax=node(i,licznikmax)
          nmin=node(i,licznikmin)
          xnmax=coordnode(nmax,1)
          xnmin=coordnode(nmin,1)
          ynmax=coordnode(nmax,2)
          ynmin=coordnode(nmin,2)
        end if
      end do       
     
! calculating the coordinates of the crack tip
      a=(p(nmax)-p(nmin))/(xnmax-xnmin)
      b=p(nmax)-a*xnmax
      cracktipx=-b/a
      if (xnmax.eq.xnmin) cracktipx=xnmax
      a=(p(nmax)-p(nmin))/(ynmax-ynmin)
      b=p(nmax)-a*ynmax
      cracktipy=-b/a 
      if (ynmax.eq.ynmin) cracktipy=ynmax
!     coordinates of the vertex when there is no crack yet
      if ((isphilsm.eq.0).or.(isnan(cracktipx))) then
        cracktipx=coordip(nmaxps,1)
        cracktipy=coordip(nmaxps,2)
      end if      

! finding points near the crack tip and calculating the angles
      radius=2
      do
        nec=0
        do k1=1,nip
          radius2=sqrt((coordip(k1,1)-cracktipx)**2.0+(coordip(k1,2)-cracktipy)**2.0)          
          if ((radius2.le.2*radius).and.(radius2.ge.radius)) then
            nec=nec+1
            if (nec.eq.301) exit
            coor(nec,1)=coordip(k1,1)-cracktipx
            coor(nec,2)=coordip(k1,2)-cracktipy
            omi(nec)=omi3(k1)
!           omi for a unit distance (it was assumed that at the crack tip the stress is equal to 1: f(0)=1 and f(radius2)=omi and this is a linear relationship)       
            omi(nec)=(omi(nec)-1.0)/radius2+1.0
!           calculating angle relative to crack tip
            if (coor(nec,2).eq.0.0) then
              angle(nec)=0.0
            else 
              angle(nec)=atan(coor(nec,1)/coor(nec,2))-0.5*pi
            end if        
            if (coor(nec,2).lt.0.0) then
              angle(nec)=angle(nec)-pi
            else
              if ((coor(nec,2).eq.0.0).and.(coor(nec,1).lt.0.0)) angle(nec)=-pi
            end if
!           adjusting the angle to the angle of the last increment
            if (angle(nec).lt.(-pi+anglelast)) angle(nec)=angle(nec)+2.0*pi 
            if (angle(nec).gt.( pi+anglelast)) angle(nec)=angle(nec)-2.0*pi              
!           if the angle is greater than 90 degrees to the right and less than 90 degrees to the left, then there are large interferences and we simply reject these results
            if ((angle(nec).ge.anglelast+pi/2.0).or.(angle(nec).le.anglelast-pi/2.0)) nec=nec-1
          end if
        end do
!       increase or decrease the comparative radius accordingly if there is too much or too little integration points 
        if (nec.lt.40) radius=radius*1.05
        if (nec.gt.50) radius=radius*0.95
        if ((nec.ge.40).and.(nec.le.50)) exit           
      end do

! finding angles when there is no crack yet
      if (isphilsm.eq.0.0) then
        anglelast=rotangle
        avgcoorx=0
        avgcoory=0
        do i=1,nec
          avgcoorx=avgcoorx+coor(i,1)
          avgcoory=avgcoory+coor(i,2)
        end do
        avgcoorx=avgcoorx/nec
        avgcoory=avgcoory/nec  
!       calculating anglelast relative to cracktip
        if (avgcoory.eq.0.0) then
          angleempty=0.0
        else 
          angleempty=atan(avgcoorx/avgcoory)-0.5*pi
        end if        
        if (avgcoory.lt.0.0) then
          angleempty=angleempty-pi
        else
          if ((avgcoory.eq.0.0).and.(avgcoorx.lt.0.0)) angleempty=-pi
        end if
        if (abs(anglelast-angleempty).ge.(anglelast-angleempty+pi)) anglelast=anglelast+pi
        do i=1,nec
!       adjusting the angle to the angle of the last increment
          if (angle(i).lt.(-pi+anglelast)) angle(i)=angle(i)+2.0*pi   
          if (angle(i).gt. (pi+anglelast)) angle(i)=angle(i)-2.0*pi   
        end do          
      end if 
      
! fitting a polynomial of degree m to the results and finding the zero - creating a system of equations
      m=2
	  do i=1,nec
        if ((angle(i).gt.anglelast-pi/8.0).and.(angle(i).lt.anglelast+pi/8.0)) m=4
      enddo      

! Cramer's rule to find the system of linear equations
      do i=1,m+1
        do j=1,m+1
          x(i,j)=0
          do k1=1,nec
            x(i,j)=x(i,j)+angle(k1)**(i+j-2)
          end do
        end do
        y(i)=0
        do k1=1,nec
          y(i)=y(i)+angle(k1)**(i-1)*omi(k1)
        end do
      end do  
 
! Gaussian elimination to find the polynomial
      do i=1,7
	    z(i)=0
      end do	
      do i=1,m+1
        c=x(i,i)
        y(i)=y(i)/c
        do k=1,m+1
          x(i,k)=x(i,k)/c
        end do
        if (i.lt.m+1) then
          do j=i+1,m+1
            c=x(j,i)
            y(j)=y(j)/c-y(i)
            do k=i,m+1
              x(j,k)=x(j,k)/c-x(i,k)
            end do
          end do
        end if
      end do      
      z(m+1)=y(m+1)
      do i=1,m
        z(m+1-i)=y(m+1-i)
        do j=m+2-i,m+1
          z(m+1-i)=z(m+1-i)-x(m+1-i,j)*z(j)
        end do
      end do     
      
! finding the minimum of a graph using the bisection method   
!     finding the interval in which there is a minimum on the left side of the anglelast
      a=anglelast+0.001
      i=0
      left=0
      do
        a=a-0.001
        fa=z(7)*6.0*a**5.0+z(6)*5.0*a**4.0+z(5)*4.0*a**3.0+z(4)*3.0*a**2.0+z(3)*2.0*a+z(2)
        if (fa.gt.0) i=1
        if ((fa.lt.0).and.(i.eq.1)) then
          left=1
          exit
        end if
        if (isnan(a)) exit
        if (a.lt.anglelast-pi/2.0) exit
      end do
      b=a+0.001      

 !    zero of the derivative of polynonial in a given interval
      do
        if (abs(b-a).lt.0.000001) exit
        c1=(a+b)/2.0
        fc=z(7)*6.0*c1**5.0+z(6)*5.0*c1**4.0+z(5)*4.0*c1**3.0+z(4)*3.0*c1**2.0+z(3)*2.0*c1+z(2)
        fa=z(7)*6.0*a**5.0+z(6)*5.0*a**4.0+z(5)*4.0*a**3.0+z(4)*3.0*a**2.0+z(3)*2.0*a+z(2)
        fb=z(7)*6.0*b**5.0+z(6)*5.0*b**4.0+z(5)*4.0*b**3.0+z(4)*3.0*b**2.0+z(3)*2.0*b+z(2)
        if (fc*fa.gt.0) a=c1
        if (fc*fa.le.0) b=c1
        if ((isnan(c1)).or.(isnan(fa))) exit
      end do  
      f1=z(7)*c1**6.0+z(6)*c1**5.0+z(5)*c1**4.0+z(4)*c1**3.0+z(3)*c1**2.0+z(2)*c1+z(1)      
      
!     finding the interval in which the minimum is on the right side of the anglelast
      b=anglelast-0.001
      i=0  
      right=0
      do
        b=b+0.001
        fb=z(7)*6.0*b**5.0+z(6)*5.0*b**4.0+z(5)*4.0*b**3.0+z(4)*3.0*b**2.0+z(3)*2.0*b+z(2)
        if (fb.lt.0) i=1
        if ((fb.gt.0).and.(i.eq.1)) then
          right=1
          exit
        end if
        if (isnan(b)) exit
        if (b.gt.anglelast+pi/2.0) exit
      end do
      a=b-0.001         

!     zero of the derivative of polynonial in a given interval
      do
        if (abs(b-a).lt.0.000001) exit
        c2=(a+b)/2.0
        fc=z(7)*6.0*c2**5.0+z(6)*5.0*c2**4.0+z(5)*4.0*c2**3.0+z(4)*3.0*c2**2.0+z(3)*2.0*c2+z(2)
        fa=z(7)*6.0*a**5.0+z(6)*5.0*a**4.0+z(5)*4.0*a**3.0+z(4)*3.0*a**2.0+z(3)*2.0*a+z(2)
        fb=z(7)*6.0*b**5.0+z(6)*5.0*b**4.0+z(5)*4.0*b**3.0+z(4)*3.0*b**2.0+z(3)*2.0*b+z(2)
        if (fc*fa.gt.0) a=c2
        if (fc*fa.le.0) b=c2
        if ((isnan(c2)).or.(isnan(fa))) exit
      end do
      f2=z(7)*c2**6.0+z(6)*c2**5.0+z(5)*c2**4.0+z(4)*c2**3.0+z(3)*c2**2.0+z(2)*c2+z(1)         
 
!     choosing a smaller minimum
      if ((left.eq.1).and.(right.eq.1)) then
        if (f1.lt.f2) then
          anglenew=c1
        else
          anglenew=c2
        endif
      endif
      if (left.eq.0) anglenew=c2
      if (right.eq.0) anglenew=c1
      
      notfirstinc=1
      
      return
      end
 
! subroutine to determine which nodes belong to which elements 
      subroutine obtain_relation(node)
      include 'aba_param.inc'
      dimension array(513),jrray(nprecd,513),node(99999,4)
      character*8 cvalue
      equivalence (array(1),jrray(1,1)), (array(4),cvalue)                   
      !rewinding the file 
      call dbfile(2,array,jrcd)
      i = 1
      do k1=1,999999
          !start reading output file
          call dbfile(0,array,jrcd)
          !if the end of the end of pre-step records go to 120 
          if (key .eq. 2000) go to 120
          !if the end of all records is reached go to position 120
          if (jrcd .ne. 0) go to 120
          !the key of the output table is at second possition (first is length of the array)          
          key=jrray(1,2)
          ! record 1900 contains information about element conectivity
          if (key .eq. 1900) then
            if (i.ge.1) then
              node(i,1) = jrray (1,5) ! <- first node number 
              node(i,2) = jrray (1,6) ! <- second node number
              node(i,3) = jrray (1,7) ! <- third node number
              node(i,4) = jrray (1,8) ! <- fourth node number 
            end if
            i = i + 1
          end if
      enddo          
 120  continue
      return
      end       
 
! subroutine which transmits the criterion condition and angle of crack propagation
      subroutine udmgini(findex,nfindex,fnormal,ndi,nshr,ntens,props,
     1 nprops,statev,nstatev,sess,sain,sainee,lxfem,time,
     2 dtime,temp,dtemp,predef,dpred,nfield,coords,noel,npt,
     3 klayer,kspt,kstep,inc,kdircyc,kcyclelcf,timecyc,sse,spd,
     4 scd,svd,smd,jmac,jmatyp,matlayo,laccfla,celent,drot,ori)

      include 'aba_param.inc'

      dimension findex(nfindex),fnormal(ndi,nfindex),coords(*),
     1 stress(ntens),strain(ntens),strainee(ntens),props(nprops), 
     2 statev(nstatev),predef(nfield),dpred(nfield),time(2),
     3 jmac(*),jmatyp(*),dror(3,3),ori(3,3) 
     
      dimension array(15),jarray(15)
      character*3 flgray(15)
      common /sharedf/ s(4,6)
      common /crack/ ft,anglenew,ndij
      dimension omi(4)

!     For the first three integration points, the criterion value and the crack propagation direction vector are defined as 0
      ndij=ndi
      if (npt.lt.4) then
        findex(1)=0
        do k1=1, ndi
            fnormal(k1,1) = 0.0
        end do 
      end if
      
!     For the fourth integration point    
      if (npt.eq.4) then
        ft=props(1)
        pi = 3.14159265359     
        do k1=1,4
          if (ndi.eq.3) then
             zi1=s(k1,1)+s(k1,2)+s(k1,3)
             zi2=s(k1,1)*s(k1,2)+s(k1,2)*s(k1,3)+s(k1,3)*s(k1,1)-s(k1,4)*s(k1,4)-s(k1,5)*s(k1,5)-s(k1,6)*s(k1,6)
             zi3=s(k1,1)*s(k1,2)*s(k1,3)-s(k1,1)*s(k1,6)*s(k1,6)-s(k1,2)*s(k1,5)*s(k1,5)-s(k1,3)*s(k1,4)*s(k1,4)+2*s(k1,4)*s(k1,5)*
     $       s(k1,6)
          end if
          if (ndi.eq.2) then
             zi1=s(k1,1)+s(k1,2)
             zi2=s(k1,1)*s(k1,2)-s(k1,4)*s(k1,4)
             zi3=0.0
          end if
          fi=acos((2.0*zi1**3.0-9.0*zi1*zi2+27.0*zi3)/2.0/(zi1**2.0-3.0*zi2)**1.5)/3.0
          ps=zi1/3.0+2.0*sqrt(zi1**2.0-3.0*zi2)*cos(fi)/3.0
          omi(k1)=ps/ft
        end do
!       Abaqus will calculate the average (0+0+0+4*omi(i))/4  
        findex(1)=0
        do i=1,4
          if (4*omi(i).gt.findex(1)) findex(1)=4*omi(i)
        end do
        fnormal(1,1)=-4.0*sin(anglenew)
        fnormal(2,1)=-4.0*cos(anglenew)
      end if
      
      return
      end